class WBManifestWorkerWrapper {
  constructor() {
    this.worker = new Worker('/js/wb-manifest-worker.js');
    this.worker.onmessage = e => this.onMessage(e);
    this.worker.onerror = e => console.log(e);
    this.queue = [];
  }

  onMessage(e) {
    if (this.queue.length === 0)
      throw Error('Unexpected message from worker');
    const accept = this.queue.splice(0, 1)[0];
    accept(e);
  }

  postMessage(m) {
    const prom = new Promise(accept => {
      this.queue.push(accept);
      this.worker.postMessage(m);
    });
    return prom;
  }
}

export default WBManifestWorkerWrapper;
